VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form MAIN 
   BackColor       =   &H80000000&
   Caption         =   "PUMA Draw Generator"
   ClientHeight    =   8415
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   10725
   LinkTopic       =   "Form1"
   ScaleHeight     =   8415
   ScaleWidth      =   10725
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox DSP 
      Appearance      =   0  'Flat
      Height          =   285
      Index           =   3
      Left            =   1800
      TabIndex        =   9
      Top             =   2400
      Width           =   8535
   End
   Begin VB.TextBox LABLE 
      Alignment       =   1  'Right Justify
      Appearance      =   0  'Flat
      BackColor       =   &H80000000&
      BorderStyle     =   0  'None
      Height          =   285
      Index           =   3
      Left            =   120
      TabIndex        =   8
      Text            =   "COMMAND :"
      Top             =   2400
      Width           =   1575
   End
   Begin VB.CommandButton Command2 
      BackColor       =   &H00C0FFFF&
      Caption         =   "RUN PUMA COMMANDS"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      Style           =   1  'Graphical
      TabIndex        =   7
      Top             =   1920
      Width           =   3255
   End
   Begin VB.TextBox LABLE 
      Alignment       =   1  'Right Justify
      Appearance      =   0  'Flat
      BackColor       =   &H80000000&
      BorderStyle     =   0  'None
      Height          =   285
      Index           =   2
      Left            =   120
      TabIndex        =   6
      Text            =   "LOG File Name :"
      Top             =   1440
      Width           =   1575
   End
   Begin VB.TextBox DSP 
      Appearance      =   0  'Flat
      Height          =   285
      Index           =   2
      Left            =   1800
      TabIndex        =   5
      Top             =   1440
      Width           =   8535
   End
   Begin VB.TextBox DSP 
      Appearance      =   0  'Flat
      Height          =   285
      Index           =   1
      Left            =   1800
      TabIndex        =   4
      Top             =   1080
      Width           =   8535
   End
   Begin VB.TextBox LABLE 
      Alignment       =   1  'Right Justify
      Appearance      =   0  'Flat
      BackColor       =   &H80000000&
      BorderStyle     =   0  'None
      Height          =   285
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Text            =   "Output File Name :"
      Top             =   1080
      Width           =   1575
   End
   Begin VB.TextBox DSP 
      Appearance      =   0  'Flat
      Height          =   285
      Index           =   0
      Left            =   1800
      TabIndex        =   2
      Top             =   720
      Width           =   8535
   End
   Begin VB.TextBox LABLE 
      Alignment       =   1  'Right Justify
      Appearance      =   0  'Flat
      BackColor       =   &H80000000&
      BorderStyle     =   0  'None
      Height          =   285
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Text            =   "Input File Name :"
      Top             =   720
      Width           =   1575
   End
   Begin MSComDlg.CommonDialog filez 
      Left            =   4800
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton Command1 
      Caption         =   "PROCESS  XYZ  FILE"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3255
   End
End
Attribute VB_Name = "MAIN"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()
' Convert XYZ file into PUMA Code
Command1.Enabled = False
Command1.Caption = "Working"
Cls
filez.Filter = "xyz"
filez.FileName = "*.xyz"
filez.ShowOpen

DSP(0).Text = filez.FileName
DSP(1).Text = Left$(DSP(0).Text, Len(DSP(0).Text) - 3) + "PUMA"
DSP(2).Text = Left$(DSP(0).Text, Len(DSP(0).Text) - 3) + "LOG"
'
Open DSP(0).Text For Input As 1 ' Input File
Open DSP(1).Text For Output As 2 ' PUMA File
Open DSP(2).Text For Output As 3 ' LOG File
'
Print #2, "APPRO ORIGIN, 50"
Print #2, "MOVE ORIGIN"
Print #2, "TYPE CONVERTED DATA STARTS HERE"
Print #2, "TYPE -------------------------------"
Dim a, z As Integer ' Move/Draw (0 or 1) and PEN location (0 or 20)
Dim b, c As Double ' Inbound data
Dim x1, y1 As Double ' Current location
Dim x2, y2 As Double ' Difference
Dim x3, y3 As Double ' Drawing Variables
Dim xt, yt, zt As String ' String version of location
Dim prt As String ' Print String
Dim upsize As Integer ' Scaling factor
Dim vertoffset As Integer ' allow for screen size
upsize = 15 ' Make larger for VB Screen
vertoffset = MAIN.Height - 1000
x1 = 0: y1 = 0: z = 0 ' Set to stating (origin) location
x2 = 0: y2 = 0: x3 = 0: y3 = 0 ' Set working points to origin.
'----------------------------------------------------------------
' Open data and create DRAW file
'----------------------------------------------------------------
While Not EOF(1)
' Get X/Y data from file
Input #1, a, b, c
' Process PEN height location
If a = 0 And z = 0 Then
    ' Need to move PEN up 20mm... away from paper
    Print #2, "TYPE PEN UP"
    Print #2, "DRAW  000.000000, 000.000000, 020.000000"
    z = 20
End If
If a = 1 And z = 20 Then
    ' Need to move PEN to paper... down 20mm
    Print #2, "TYPE PEN DOWN"
    Print #2, "DRAW  000.000000, 000.000000,-020.000000"
    z = 0
End If
' Process X and Y data
x2 = b - x1 ' set x2 to the x-offset
y2 = c - y1 ' set y2 to the y-offset
x3 = x1: y3 = y1
x1 = b: y1 = c  ' Update current location
'
If z = 0 Then
Line ((x1 * upsize) + 500, vertoffset - (y1 * upsize))-((x3 * upsize) + 500, vertoffset - (y3 * upsize))
End If

xt = Format(x2, "000.000000")
yt = Format(y2, "000.000000")
prt = "DRAW " + xt + "," + yt + ",000.000000"
Print #2, prt
xt = Format(x1, "000.000000")
yt = Format(y1, "000.000000")
If z = 0 Then zt = "- DN"
If z = 20 Then zt = "+ UP"
prt = "LOCATION " + xt + "," + yt + "," + zt
Print #3, prt
Wend
'----------------------------------------------------------------
' Cleanup and finish
'----------------------------------------------------------------
If z = 0 Then
    ' Need to move PEN up 20mm... away from paper
    Print #2, "DRAW 000.000000,000.000000,020.000000"
End If
Print #2, "TYPE PEN IS UP, PROGAM COMPLETED."
Print #2, "TYPE -------------------------------"
Close
Command1.Caption = "DONE"
If Len(DSP(2).Text) > 4 Then Command2.Enabled = True
End Sub

Private Sub Command2_Click()
' Open PUMA Code and send to serial port.
' Actually run the PUMA Arm remotely.
Command1.Enabled = False
Command1.Caption = "DISABLED"
Cls
filez.Filter = "PUMA"
filez.FileName = "*.PUMA"
filez.ShowOpen

DSP(0).Text = filez.FileName
DSP(1).Text = "N/A"
DSP(2).Text = "N/A"
Dim cmd As String

Open DSP(0).Text For Input As 1
While Not EOF(1)
Line Input #1, cmd
DSP(3).Text = cmd
Wend
Close
End Sub
